//
//  TitleScene.h
//  SampleApp
//
//  Created by Hiroki Azumada on 2014/06/08.
//
//

#ifndef __SampleApp__TitleScene__
#define __SampleApp__TitleScene__

#include "cocos2d.h"
#include "MainScene.h"

class Title : public cocos2d::CCLayer
{
public:

    static cocos2d::CCScene* createScene();

    virtual bool init();
    
    void menuCloseCallback(CCObject* pSender);
    void menuStartCallback(CCObject* pSender);
    void menuStart2Callback(CCObject* pSender);
    void menuStart3Callback(CCObject* pSender);
    void menuStartWithBatchCallback(CCObject* pSender);
    void menuStart2WithBatchCallback(CCObject* pSender);
    void menuTextureFormatToggleCallback(CCObject* pSender);
    void menuRandomScaleToggleCallback(CCObject* pSender);
    
	void changeScene(GameState::Mode mode, bool useSpriteBatchNode = false);
	void createMenuItem(cocos2d::CCArray* buttons, cocos2d::CCPoint position, const std::string& label, cocos2d::SEL_MenuHandler selector);
	cocos2d::CCMenu* createToggleButton(const std::string& offTexName, const std::string& onTexName, cocos2d::CCObject* target, cocos2d::SEL_MenuHandler selector, unsigned int initialIndex);

    // implement the "static create()" method manually
    CREATE_FUNC(Title);
};

#endif /* defined(__SampleApp__TitleScene__) */
