#ifndef __TEST_SCENE_H__
#define __TEST_SCENE_H__

#include "cocos2d.h"

USING_NS_CC;

class Test : public cocos2d::Layer
{
public:
	// there's no 'id' in cpp, so we recommend returning the class instance pointer
	static cocos2d::Scene* createScene();

	// Here's a difference. Method 'init' in cocos2d-x returns bool, instead of returning 'id' in cocos2d-iphone
	virtual bool init();

	void exitApp();

	// implement the "static create()" method manually
	CREATE_FUNC(Test);

	virtual void update(float delta);



private:
	int imgIndex;
	int powCounter;

	void addSprite();
	void addSprite(int addNum);
	void removeSprite();

	Size visibleSize;
	Point* getNextPosition();

	Label* numberLabel;
    
    void onKeyReleased(cocos2d::EventKeyboard::KeyCode keyCode, cocos2d::Event* event);
};

#endif // __TEST_SCENE_H__
